using System.Collections;
using System;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.InputSystem;


namespace BigSock {

	/*
		class represents the stats of a character.
	*/
	public class CharacterStats : ICharacterStats {
		/*
			The hp of the character.
		*/
		public float MaxHP { get; set; }

		/*
			The max mana of the character.
		*/
		public float MaxMana { get; set; }

		/*
			The max stamina of the character.
		*/
		public float MaxStamina { get; set; }

		/*
			The regeneration rate of the character's mana.
		*/
		public float RegenMana { get; set; }

		/*
			The regeneration rate of the character's stamina.
		*/
		public float RegenStamina { get; set; }



		/*
			The damage of the character.
		*/
		public float Damage { get; set; }

		/*
			The movement speed of the character.
		*/
		public float MoveSpeed { get; set; }
		
		/*
			The projectile speed of the attack.
		*/
		public float ProjectileSpeed { get; set; }

		/*
			The knockback of the character.
		*/
		public float Knockback { get; set; }

		/*
			The range of the character.
		*/
		public float Range { get; set; }

		/*
			The attack speed of the character.
		*/
		public float AttackSpeed { get; set; }

		/*
			The crit chance of the character.
		*/
		public float CritChance { get; set; }
		
		/*
			The how much to modify damage by when critting.
		*/
		public float CritDamageModifier { get; set; }
	}
}